#ifndef SYSTEM_H
#define SYSTEM_H
#include "Polymers.h"
#include "PolymersDamped.h"

using namespace std;

class Corr;

class System{
   friend class Polymers;
   private:
   int RepLength; 
   int NumIts; 
   int GigTime; 
   int EquilTime; 
   int NumItsDone;
   bool GraphOn;
   bool Done;
   Polymers * polymers;
   Corr * corr;
   public:
   System(int RepLength, int NumIts, int GigTime, int EquilTime, bool GraphOn);
   Polymers * getPolymers() const;
   void setPolymers(Polymers * polymers);
   int getRepLength() const; 
   int getNumIts() const; 
   int getGigTime() const; 
   int getEquilTime() const; 
   bool getGraphOn() const;
   int getNumItsDone() const;
   void incrItsDone();
   void setCorr(Corr * corr);
   Corr * getCorr();
   bool getDone();
   void setDone();
};

   inline int System::getRepLength() const{
      return RepLength;
   }

   inline int System::getNumIts() const{
      return NumIts;
   }

   inline int System::getNumItsDone() const{
      return NumItsDone;
   }


   inline int System::getGigTime() const{
      return GigTime;
   }

   inline int System::getEquilTime() const{
      return EquilTime;
   }

   inline bool System::getGraphOn() const{
      return GraphOn;
   }

   inline void System::incrItsDone() {
      NumItsDone++;
   }

   inline void System::setPolymers(Polymers * polymers){
      this->polymers = polymers;
   }

   inline Polymers * System::getPolymers() const {
      return polymers;
   }

   inline void System::setCorr(Corr * corr){
      this->corr = corr;
   }

   inline void System::setDone(){
      Done = true;
   }

   inline bool System::getDone(){
      return Done;
   }

   inline Corr * System::getCorr() {
      return corr;
   }



#endif// SYSTEM_H
