
import numpy
from scipy import *
from pylab import *
import time
import sys
#import numpy as npy

def randdir():
    n = randint(6)
    return dir[n]

def randsphere(radius = 10.0):
    while 1:
        r = numpy.random.random(3) - array((0.5,0.5,0.5))
        rsq = sum(r*r)
        if rsq < 1:
            return radius*r/sqrt(rsq)


def intrandsphere(radius): 
    return ceil(randsphere(radius))

Seed = 10000
seed(Seed)
    
dir = array( [ [1,0,0], [-1,0,0], [0,1,0], [0,-1,0], [0,0,1], [0,0,-1]])

r = zeros((3))
graphics = 0
if graphics:
    from visual import *

starting_radius = 20
outer_radius = starting_radius*2
outer_radius_sq = outer_radius**2


num_absorbed = 0
num_escaped = 0

absorb_radius = 3
absradsq = absorb_radius**2

y_offset = -3
r_offset = array((0,y_offset,0))

if (graphics):
   floor = box (pos=(0,y_offset,0), length=40, height=1.0, width=40, color=color.blue)
   rod = cylinder(pos=(0,y_offset,0), axis=(0,1.00,0), radius=absorb_radius, color=color.red)
   ball = sphere (pos=(0,10+y_offset,0), radius=0.3, color=color.green)
   ion()

for i in range(1000000):
    r = intrandsphere(starting_radius)
    if r[1] < 0:
        r[1] = -r[1]

    if graphics:
        ball.radius = 0.3
        ball.color = color.red

    while 1:

        if graphics:
            rate(10)
            ball.pos= r + r_offset


        if r[0]**2+r[2]**2 <= absradsq and r[1] <= 0 :
            num_absorbed += 1
            if graphics or  num_absorbed % 100 == 0:
                print "num absorbed = ", num_absorbed
            if graphics:
                ball.radius = absorb_radius
                ball.color = color.white
            break
 
            key = scene.kb.getkey()
            if (key == 'q'): 
                break

        if sum(r*r) > outer_radius_sq:
            num_escaped += 1
            if graphics or num_escaped % 100 == 0:
                print "num escaped = ", num_escaped, " num_absorbed/(num_absorbed+num_escaped) = ", num_absorbed/(1.0*num_absorbed+num_escaped) 
            break

        if  r[1] <= 0:
            r[1] = 1

        r += randdir()

    

print "num_absorbed/(num_absorbed+num_escaped) = ", num_absorbed/(1.0*num_absorbed+num_escaped)
