

from scipy import *
from pylab import *

C1 = 1/6.0
C2 = 1/12.0
Eps = 0

def diffuse(p, c1=C1, c2=C2, eps=Eps):
    #p[1:-1,1:-1] = c1*(p[0:-2,1:-1] + p[2:,1:-1] + p[1:-1,0:-2] + p [1:-1,2:]) + c2*(p[0:-2,0:-2] + p[2:,2:] + p[0:-2,2:] + p[2:,0:-2])
    p[1:-1,1:-1] =  eps*p[1:-1,1:-1] + (1.-eps)*(c1*(p[0:-2,1:-1] + p[2:,1:-1] + p[1:-1,0:-2] + p [1:-1,2:]) + c2*(p[0:-2,0:-2] + p[2:,2:] + p[0:-2,2:] + p[2:,0:-2]))
    return




def set_square(arr,value,center,r):
   for x in range(-r,r): 
      for y in range(-r,r):
	 arr[center[0]+x,center[1]+y] = value
   return



nx = 256
ny = 256
dims = (nx,ny)
dt = 0.1
T0 = -1.0 
a= T0
phi_0 = -1.0 
C=0.5


dphi = zeros((nx,ny))
T = a*ones(dims,dtype=float)
phi = phi_0*ones(dims,dtype=float)
set_square(phi,1.0,(nx/2,ny/2),4)
set_square(T,-0.2,(nx/2,ny/2),16)
T += 0.01*standard_normal(dims)
phi += 0.01*standard_normal(dims)

ion()

for k in range(50000):
    diffuse(T)
    T[:,0] = T0
    T[0,:] = T0
    T[-1,:] = T0
    T[:,-1] = T0
    #diffuse_ani(phi)
    diffuse(phi,c1=0.25,c2=-0.0,eps=0.5)
    #diffuse(phi,c1=0.1,c2=0.15,eps=0.75)
    #diffuse(phi,c1=0.35,c2=-0.1,eps=0.5)
    phi[:,0] = -1.
    phi[0,:] = -1.
    phi[-1,:] = -1.
    phi[:,-1] = -1.

    dphi =  -dt*(4*phi*(phi*phi-1)+T)
    phi += dphi
    T +=  C*dphi
    if 0 or k%50 == 0: 
        imshow(phi)
	draw()
        pause(0.0001)
#        print phi[nx/5,ny/5]
        #plot(phi[:,ny/2])
        #plot(T[:,ny/2])
        #cla()
        if (phi[nx/5,ny/5] > 0.2): break
  
show()
  


