from scipy import *
from pylab import *
import time
import weave
from weave import converters

def walk(p,num,n,max_r,cluster_size):
   code = """
   #line 9 "dla_c.py"
   #include <stdlib.h>
   #include <stdio.h>
   #include <string.h>
   #include <math.h>
   #define ran() (rand()/(RAND_MAX+1.0))
   #define SQR(a) ((a)*(a))

      int pad = 100;
      double x,y, max_rsq = SQR(max_r(0));
      int dir[2][4] = {{0,0,1,-1},{1,-1,0,0}};
      int r[2];

      int ran_dir;
      int count;
      int n2 = n/2;


      for (count = 0; count <  num; count++)
      {
      int hit=0;
      int init_rad = max_r(0)+4;
      double rsq;
      while (1)//get random position on circle
      {
         x = 2*(ran()-0.5);
         y = 2*(ran()-0.5);
         rsq = x*x+y*y;
         if (rsq < 1)
         {
            r[0]  = init_rad*x/sqrt(rsq);
            r[1]  = init_rad*y/sqrt(rsq);
            break;
         }
      }
      while ((r[0]*r[0] + r[1]*r[1]) < SQR(init_rad*2))
      {
         int k;
         for(k=0; k < 4; k++)
         {
            int neighx = n2+r[0] + dir[0][k];
            int neighy = n2+r[1] + dir[1][k];

            if (p(neighx,neighy) > 0)
            {
               hit = 1;
               break;
            }
         }
         if (hit)
         {
            cluster_size(0)++;
            p((r[0] + n2),(r[1] + n2)) = sqrt(cluster_size(0));
            int tmp = r[0]*r[0]+r[1]*r[1]; 
            if (tmp > max_rsq)
            {
               max_rsq = tmp;
               max_r(0) = sqrt(tmp);
            }
            break;
         }

         ran_dir =  4*ran();
         r[0] += dir[0][ran_dir];
         r[1] += dir[1][ran_dir];

      }
   }
   """
   weave.inline(code, ['p','num','n','max_r','cluster_size'], type_converters=converters.blitz, compiler = 'gcc')



n=1024
dim = (n,n)
p = zeros(dim, dtype=double)
max_r = zeros((1))
max_r[0] = 10
center = (n//2,n//2)
p[center] = 1
#If you want to start off with two seeds:
#max_r[0] = 100
#p[(n//2,n//2-16)] = 1
#p[(n//2,n//2+16)] = 1
cluster_size = zeros((1))

rcParams['figure.figsize'] = 9, 9 
num=100
low = n//3
high = n-n//3

ion()

for i in range(1000000):
    walk(p,num,n,max_r,cluster_size)
    if p[n//2,n//2] > 1:
       print("p center = ", p[n//2,n//2])
    if max_r[0] > n//6:
        time.sleep(100.0)
    if True  or i%10 == 0:
        imshow(p[low:high,low:high],interpolation="nearest")
        draw()
        pause(0.0001)
        print(i)
        time.sleep(0.01)

print("done")
show()
