from scipy import *
from pylab import *

dir = array([ [1,0], [-1,0], [0,1], [0,-1]])

def randdir():
    n = randint(4)
    return dir[n]


n=64
dim = (n,n)

p = zeros(dim)
center = (n//2,n//2)
p[center] = 1
d=2


def new_chain(length):
    r = zeros((length,d), dtype = int)
    r[0] = center
    p[tuple(r[0,:])] = 1
    for i in range(1,length):
        r[i,:] = r[i-1,:] + randdir()
        p[tuple(r[i,:])] = 1
    return r

length = 128
r_tmp = zeros((length,d), dtype = int)
reptator = list(range(0,length))
r = new_chain(length)

p[:,0] = p[:,-1] = p[0,:] = p[-1,:] = 1

graphics= True
if graphics:
    from vpython import *

    def vc(r):
        if d== 3:
           return vector(r[0],r[1],r[2])
        elif d==2:
           return vector(r[0],r[1],0)

    ball = []
    cyl = []
    for i in range(length-1):
        cyl.append(cylinder (pos=vc(r[i]), axis=vc(r[i+1]-r[i]), color=color.red, radius = 0.2))

    #floor = box (pos=(center[0],center[1],-4), length=n, height=0.5, width=4, color=color.blue)

display_interval = 1

ion()

print("sum p = ", sum(p))
for j in range(0,2000):
    if graphics:
        rate(10000)
    head = length-1
    for i in range(0,100):
        WhichEnd = randint(2)
        HeadOrTail = (head + WhichEnd)%length
        TailOrHead = (head + 1-WhichEnd)%length
        r_new = r[HeadOrTail,:] + randdir()
        p[tuple(r[TailOrHead,:])] -= 1
        if p[tuple(r_new)] == 1:
           # move failed so reset:
           p[tuple(r[TailOrHead,:])] += 1
        else:
           head = (head - 2 * WhichEnd + 1 + length)%length
           r[(head + WhichEnd)%length,:] = r_new
           p[tuple(r_new)] = 1

    tail = (head + 1 + length)%length
    r_tmp[length-tail:,:] =  r[:tail,:]
    r_tmp[:length-tail,:] = r[tail:,:]
    r[:,:] = r_tmp[:,:]
    if j%display_interval == 0 : 
        if  graphics:
            for k in range(length-1):
                cyl[k].pos = vc(r[k])
                cyl[k].axis = vc(r[k+1]-r[k])
    print("sum p = ", sum(p))


    

