#ifndef GRAPHICS_H 
#define GRAPHICS_H

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include "defs.h"

typedef struct {
   GLUquadricObj *qobj;
} GRAPHICS;

void init();
void display(void);
void reshape (int w, int h);
void reshape1 (int w, int h);
void keyboard(unsigned char key, int x, int y);
void idle();
void graph_cylinder( double * begin, double * end, double radius);
void graph_sphere(double * center, double radius);
void register_window(int win);
void motion(int x, int y);
void mouse(int button, int state, int x, int y);
void rotate(int x, int y, int z);
void button(int button, int state);
#endif //GRAPHICS_H
